unit Loch1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,LCLIntf,
  LCLType, math;

type


  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  private
    mx,my : integer;
    poly : array[0..366] of Tpoint;
    procedure createPoly;


  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const Deg2Rad = pi/180;


{ TForm1 }

(*
  3 Ecken - Mitte aussen - Ansatz Kreis - 360 -  - Mitte aussen - 4. ecke = 7+360 = 367
*)


procedure TForm1.createPoly;
var i,alpha,radius: integer;
    sinus,cosinus : single;
    P1,P2, center : TPoint;
begin
radius := height div 2 -10;
Center  := Point(width div 2, height div 2);
P1 := Point(width, height div 2);
P2 := Point(width div 2 +radius, Height div 2);
poly[0] := Point(0,0);
Poly[1] := Point(0,height);
Poly[2] := Point(width,height);
Poly[3] := P1;
Poly[4] := P2;
alpha := 1 ;
for alpha := 1 to 359 do
begin
math.SinCos(alpha * deg2Rad, sinus, cosinus);
poly[alpha+4] := Point(round(cosinus*radius),round(sinus*radius)) + Center;
end; // alpha
poly[364] := P2;
poly[365] := P1;
Poly[366] := Point(width,0);
end;


procedure TForm1.Button1Click(Sender: TObject);
var Region: HRGN;

begin
  CreatePoly;
  Region := CreatePolygonRgn(Poly,367,ALTERNATE);
  SetWindowRgn(Handle, Region, true);
  DeleteObject(Region);
end;

procedure TForm1.Button2Click(Sender: TObject);
var Region: HRGN;
begin
  Region := CreateRectRgn(0,0,width,height);
  SetWindowRgn (Handle,Region,true);
  DeleteObject(Region);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button2Click(Nil);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mx := x;
  my := y;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var dx, dy : integer;
begin
  if ssLeft in Shift then
  begin
   dx := x-mx;
   dy := y - my;
   left := left + dx;
   top := top + dy;
  end;
end;

end.

